<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class admincomposemessage
{
    protected $lang;
    protected $template_metadata;
    protected $user_list;
    protected $form_status = false;
    protected $form_message;
    protected $form_style;
    protected $display_form = false;


    /*
     * Constructor -------------------------------------------------------------
     */
    public function admincomposemessage($lang=array())
    {
        $this->lang = $lang;
        
        // process sendmail form.
        if( isset($_POST['bodyInput']) )
        {
            $this->handleSendMail();
        }
        
        // load user list.
        $this->loadUserList();
        
        // load sendmail template.
        $this->loadTemplateMetadata();
    }
    
    /*
     * Protected method: load user list ----------------------------------------
     * @return void.
     */
    protected function loadUserList()
    {
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !$sql = @mysql_query("SELECT `email`, `name` FROM `register` ORDER BY `name` ASC") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to load user list at ' . __FILE__ . ':' . __LINE__.'. ' . mysql_error());
            LogReport::fatalError($this->lang['COMP_QUERY_USERLIST_ERROR']);
        }
        
        if( @mysql_num_rows($sql) < 1 )
        {
            $db->close();
            
            $this->form_status = true;
            $this->form_message = $this->lang['COMP_NOUSER_LISTED'];
            $this->form_style = 'alert-info';
            return;
        }
        
        $this->user_list = array();
        
        while( $r = @mysql_fetch_assoc($sql) )
        {
            $obj = array(
                'email' => $r['email'],
                'name' => $r['name']
            );
            
            array_push($this->user_list, $obj);
        }
        
        @mysql_free_result($sql);
        $db->close();
        
        $this->display_form = true;
    }

    /*
     * Protected method: load template metadata --------------------------------
     * @return void.
     */
    protected function loadTemplateMetadata()
    {
        $path = BASE_ROOT . 'view/email/template.html';
        
        if( !file_exists($path) )
        {
            $this->template_metadata = '';
        }
        else
        {
            if( $fo = @fopen($path, 'r') )
            {
                if( !$data = @fread($fo, filesize($path)) )
                {
                    require_once BASE_CLASS . 'class-log.php';
                
                    LogReport::write('Unable to read sendmail template at ' . __FILE__ . ':' . __LINE__ . '. Probable cause: access denied (read).');

                    $this->template_metadata = '';
                }
                else
                {
                    $this->template_metadata = $data;
                }
                
                @fclose($fo);
            }
            else
            {
                require_once BASE_CLASS . 'class-log.php';
                
                LogReport::write('Unable to load sendmail template at ' . __FILE__ . ':' . __LINE__ . '.');
                
                $this->template_metadata = '';
            }
        }
    }
    
    /*
     * Protected method: handle sendmail form ----------------------------------
     * @return void.
     */
    protected function handleSendMail()
    {
        $message = stripslashes($_POST['bodyInput']);
        $subject = trim($_POST['subjectInput']);
        $subject = stripslashes($subject);
        $subject = htmlentities($subject);
        $to = trim($_POST['userInput']);
        $name = trim($_POST['destname']);
        $name = stripslashes($name);
        $name = htmlentities($name);
        
        // add HTML tags.
        $html = '<html><head><title>' . FRAMEWORK_NAME . '</title></head><body>';
        $html .= $message;
        $html .= '</body></html>';
        
        // validate.
        if( $to == 'none' )
        {
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_message = $this->lang['COMP_SELECT_USER'];
            return;
        }
        
        require_once BASE_CLASS . 'class-utilities.php';
        
        if( !Utilities::checkEmail($to) )
        {
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_message = $this->lang['COMP_INVALID_EMAIL'];
            return;
        }
        
        if( empty($subject) )
        {
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_message = $this->lang['COMP_INVALID_SUBJECT'];
            return;
        }
        
        // send message.
        $headers  = 'MIME-Version: 1.0' . "\r\n";
        $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
        $headers .= 'To: '.$name.' <'.$to.'>' . "\r\n";
        $headers .= 'From: '.FRAMEWORK_NAME.' <'.ADMIN_CONTACT_EMAIL.'>' . "\r\n";
        $headers .= 'X-Mailer: ' . FRAMEWORK_NAME;
        
        if( !@mail($to, $subject, $html, $headers) )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to send email at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_message = $this->lang['COMP_SENDMAIL_ERROR'];
            
            return;
        }
        
        $this->form_status = true;
        $this->form_style = 'alert-success';
        $this->form_message = $this->lang['COMP_SENDMAIL_SUCCESS'];
        
        return;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string (alert-error|alert-warning|alert-info)
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get user list --------------------------------------------
     * @return array.
     */
    public function getUserList()
    {
        return $this->user_list;
    }

    /*
     * Public method: get template metadata ------------------------------------
     * @return string (HTML)
     */
    public function getTemplateMetadata()
    {
        $this->template_metadata = str_replace('[:::MESSAGE:::]', '', $this->template_metadata);
        return $this->template_metadata;
    }
    
    /*
     * Public method: get display form state -----------------------------------
     * - will evaluate to true only if user list loads.
     * @return bool.
     */
    public function getFormDisplayState()
    {
        return $this->display_form;
    }
}