<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################

class adminmenumanager 
{
    protected $lang;
    protected $form_message;
    protected $form_status;
    protected $form_style;
    protected $form_type;
    protected $menu_list;
    protected $page_list;
    protected $link_list;
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function adminmenumanager($lang=array())
    {
        $this->lang = $lang;
        
        // handle save new anchor form.
        if( isset($_POST['savePageBtn']) )
        {
            $this->handleSaveForm();
        }
        
        // handle order up list form.
        if( isset($_POST['upBtn']) )
        {
            $this->handleUpForm();
        }
        
        // handle order down list form.
        if( isset($_POST['downBtn']) )
        {
            $this->handleDownForm();
        }
        
        // handle update anchor label form.
        if( isset($_POST['updateBtn']) )
        {
            $this->handleUpdateForm();
        }
        
        // handle remove anchor form.
        if( isset($_POST['deleteBtn']) )
        {
            $this->handleDeleteForm();
        }
        
        // handle enable form.
        if( isset($_POST['enabledBtn']) )
        {
            $this->handleEnableForm();
        }
        
        // load menu and page list.
        $this->loadList();
    }
    
    /*
     * Private method: handle enable/disable button form -----------------------
     */
    private function handleEnableForm()
    {
        $menuid = (int)trim($_POST['idHidden']);
        $topicId = (int)$_POST['topicidHidden'];
        $enabled = trim($_POST['enabledHidden']);
        
        if( (bool)$enabled ? $enabled = '0' : $enabled = '1' );
        
        // update anchor.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !@mysql_query("UPDATE `menu_link` SET `enabled`='$enabled' WHERE `id`='$menuid' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update enabled status for menu_link due a query error at ' . __FILE__ . ':' . __LINE__ .'. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_ENABLED_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_ENABLED_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: delete anchor form --------------------------------------
     */
    private function handleDeleteForm()
    {
        $menuid = (int)trim($_POST['idHidden']);
        $topicId = (int)$_POST['topicidHidden'];
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // remove anchor.
        if( !@mysql_query("DELETE FROM `menu_link` WHERE `id`='$menuid' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to remove anchor due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_REMOVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        // get remaining menu anchors id.
        if( !$sql = @mysql_query("SELECT `id`,`menu_topic_id`,`order` FROM `menu_link` WHERE `menu_topic_id`='$topicId' ORDER BY `order` ASC") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('URGENT: Menu could not be re-indexed (reordered) for menu_topic_id ['.$topicId.'] due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_REMOVE_QUERY_INDEX_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( @mysql_num_rows($sql) > 0 )
        {
            $ids = array();
            
            while( $r = mysql_fetch_assoc($sql) )
            {
                array_push($ids, $r['id']);
            }
            
            @mysql_free_result($sql);
            
            // update menu indexes.
            for( $i=0; $i < count($ids); $i++ )
            {
                $count = ($i+1);
                $id = $ids[$i];
                
                @mysql_query("UPDATE `menu_link` SET `order`='$count' WHERE `id`='$id' LIMIT 1;");
            }
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_REMOVE_ANCHOR_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: update anchor label form --------------------------------
     */
    private function handleUpdateForm()
    {
        $menuid = (int)trim($_POST['idHidden']);
        $topicId = (int)$_POST['topicidHidden'];
        $label = trim($_POST['labelInput']);
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $label = mysql_real_escape_string($label);
        
        if( !@mysql_query("UPDATE `menu_link` SET `label`='$label' WHERE `id`='$menuid' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_LABEL_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_UPDATE_LABEL_QUERY_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: handle order down form ----------------------------------
     */
    private function handleDownForm()
    {
        $menuid = (int)trim($_POST['idHidden']);
        $order  = (int)$_POST['orderHidden'];
        $topicId = (int)$_POST['topicidHidden'];
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // get id.
        if( !$sql = mysql_query("SELECT `id` FROM `menu_link` WHERE `menu_topic_id`='$topicId'") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $last_order = mysql_num_rows($sql);
        
        // if last order is 1, break ops.
        if( $last_order < 2 )
        {
            $cnx->close();
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_ALREADY_LAST'];
            $this->form_status = true;
            $this->form_style = 'alert-info';
            
            return;
        }
        
        // set next order index.
        $norder = $order + 1;
        
        // if next order is equal or greater than last order, it means it is 
        // already at the bottom.
        if( $norder > $last_order )
        {
            $cnx->close();
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_ALREADY_LAST'];
            $this->form_status = true;
            $this->form_style = 'alert-info';
            
            return;
        }
        
        // get older entry id.
        if( !$sql = mysql_query("SELECT `id`,`menu_topic_id`,`order` FROM `menu_link` WHERE `menu_topic_id`='$topicId' AND `order`='$norder' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( mysql_num_rows($sql) != 1 )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $id = mysql_fetch_assoc($sql);
        $id = $id['id'];
        
        @mysql_free_result($sql);
        
        // update older entry.
        if( !mysql_query("UPDATE `menu_link` SET `order`='$order' WHERE `id`='$id' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        // update new entry order.
        if( !mysql_query("UPDATE `menu_link` SET `order`='$norder' WHERE `id`='$menuid' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_DOWN_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['MENU_UPDATE_DOWN_SUCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
                
        return;
    }
    
    /*
     * Private method: handle order up form ------------------------------------
     */
    private function handleUpForm()
    {
        $menuid = (int)trim($_POST['idHidden']);
        $order  = (int)$_POST['orderHidden'];
        $topicId = (int)$_POST['topicidHidden'];
        
        // check if previous order is less than 1.
        if( $order < 2 )
        {
            $this->form_message = $this->lang['MENU_ORDER_UP_MINIMUM_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-info';
            
            return;
        }
        
        // update old order.
        $norder = ($order-1);
        
        // if new order is less than 1 it means it is already at the top.
        if( $norder < 1 )
        {            
            $this->form_message = $this->lang['MENU_ORDER_UP_MINIMUM_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-info';
            
            return;
        }
        
        // connect to database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // get older entry id.
        if( !$sql = mysql_query("SELECT `id`,`menu_topic_id`,`order` FROM `menu_link` WHERE `order`='$norder' AND `menu_topic_id`='$topicId' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        // if is not 1 it means it is already at the top.
        if(mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            
            $this->form_message = $this->lang['MENU_ORDER_UP_MINIMUM_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-info';
            
            return;
        }
        
        $id = mysql_fetch_assoc($sql);
        $id = $id['id'];
                
        @mysql_free_result($sql);
               
        if( !mysql_query("UPDATE `menu_link` SET `order`='$order' WHERE `id`='$id' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        // update new order.
        if( !mysql_query("UPDATE `menu_link` SET `order`='$norder' WHERE `id`='$menuid' LIMIT 1;") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to update menu_link table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
            
        $this->form_message = $this->lang['MENU_UPDATE_QUERY_UP_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';

        return;
    }
    
    /*
     * Private method: handle save anchor form ---------------------------------
     */
    private function handleSaveForm()
    {
        $menuId  = trim($_POST['menuInput']);
        $pageUrl = trim($_POST['pageInput']);
        $anchorLabel = trim($_POST['anchorInput']);
        $enabled = trim($_POST['publishInput']);
        
        // validate.
        if( !is_numeric($menuId) || empty($pageUrl) )
        {
            $this->form_message = $this->lang['MENU_INVALID_SAVE_REQUEST'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        if( strlen($anchorLabel) < 3 )
        {
            $this->form_message = $this->lang['MENU_INVALID_ANCHOR_LABEL'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        ( (bool)$enabled ? $enabled = '1' : $enabled = '0' );
        
        // check if the page is already registered on the menu list.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $menuId = mysql_real_escape_string($menuId);
        $pageUrl = mysql_real_escape_string($pageUrl);
        $anchorLabel = mysql_real_escape_string($anchorLabel);
        
        if( !$sql = mysql_query("SELECT `page_url` FROM `menu_link` WHERE `page_url`='$pageUrl' AND `label`='$anchorLabel'") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to save anchor due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_SAVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        // get count.
        $order = mysql_query("SELECT `order` FROM `menu_link` WHERE `menu_topic_id`='$menuId'");
        $order = mysql_num_rows($order);
        
        if( $order < 1 )
        {
            $order = 1;
        }
        else
        {
            $order++;
        }
        
        if( @mysql_num_rows($sql) > 0 )
        {
            $cnx->close();
            
            $this->form_message = $this->lang['MENU_SAVE_REQUEST_DENIED'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        // register anchor link.
        if( !@mysql_query("INSERT INTO `menu_link` (`label`,`page_url`,`menu_topic_id`,`order`,`enabled`) VALUES ('$anchorLabel','$pageUrl','$menuId','$order','$enabled')") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to save anchor due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_SAVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $this->form_message = $this->lang['MENU_SAVE_ANCHOR_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: load link list ------------------------------------------
     */
    private function loadLinkList()
    {
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `menu_link` ORDER BY `order` ASC") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            $cnx->close();
            
            LogReport::write('Unable to load menu link list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            LogReport::fatalError($this->lang['MENU_LINK_LIST_QUERY_ERROR']);
        }
        
        if(mysql_num_rows($sql) < 1 )
        {
            $this->link_list = array();
            $cnx->close();
            return;
        }
        
        $result = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            $obj = array();
            $obj['id'] = $r['id'];
            $obj['label'] = $r['label'];
            $obj['page_url'] = $r['page_url'];
            $obj['menu_topic_id'] = $r['menu_topic_id'];
            $obj['order'] = $r['order'];
            $obj['enabled'] = $r['enabled'];
            
            array_push($result, $obj);
        }
        
        @mysql_free_result($sql);
        $cnx->close();
        
        $this->link_list = $result;
    }
    
    /*
     * Private method: load menu and page list ---------------------------------
     */
    private function loadList()
    {
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        // load menu list.
        if( !$sql = @mysql_query("SELECT * FROM `menu_topic` ORDER BY `group`") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to load menu list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_LIST_LOAD_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            
            $this->menu_list = array();
            return;
        }
        
        $menu = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            $obj = array();
            $obj['id'] = $r['id'];
            $obj['label'] = $r['label'];
            $obj['order'] = $r['order'];
            $obj['enabled'] = $r['enabled'];
            $obj['group'] = $r['group'];
            
            array_push($menu, $obj);
        }
        
        @mysql_free_result($sql);
        
        $this->menu_list = $menu;
        
        // load page list.
        if( !$sql = mysql_query("SELECT `page_title`,`page_slug`,`page_publish`,`page_group` FROM `page` WHERE `page_publish`='1'") )
        {
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to load menu list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['MENU_LIST_LOAD_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( @mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            
            $this->page_list = array();
            return;
        }
        
        $page = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            $obj = array();
            $obj['page_title'] = $r['page_title'];
            $obj['page_slug'] = $r['page_slug'];
            $obj['page_group'] = $r['page_group'];
            
            array_push($page, $obj);
        }
        
        @mysql_free_result($sql);
        $cnx->close();
        
        $this->page_list = $page;
    }
    
    /*
     * Public method: get link menu --------------------------------------------
     * @return array.
     */
    public function getLinkList()
    {
        $this->loadLinkList();
        
        return $this->link_list;
    }
    
    /*
     * Public method: get menu list --------------------------------------------
     * @return array;
     */
    public function getGroupList()
    {
        // sort each page for each menu.
        $group = array();
        
        for( $i=0; $i < count($this->menu_list); $i++ )
        {
            if( !in_array($this->menu_list[$i]['group'], $group) )
            {
                array_push($group, $this->menu_list[$i]['group']);
            }
        }
        
        return $group;
    }
    
    public function getMenuList()
    {
        return $this->menu_list;
    }
    
    public function getPageList()
    {
        return $this->page_list;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
    
    /*
     * Public method: get form type --------------------------------------------
     * @return string.
     */
    public function getFormType()
    {
        return $this->form_type;
    }
}
