<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminreservationpolicy {
    protected $lang;
    protected $form_status;
    protected $form_message;
    protected $form_style;
    
    /**
     * Constructor
     * <br>---------------------------------------------------------------------
     */
    public function adminreservationpolicy($lang=array()){
        $this->lang = $lang;
        
        // handle update form.
        if( isset($_POST['savebtn']) ){
            $this->handleUpdateForm();
        }
    }
    
    /**
     * Private method: handle update form
     * <br>---------------------------------------------------------------------
     * @return void
     */
    private function handleUpdateForm(){
        $html = trim($_POST['reservationInput']);
        $html = stripslashes($html);
        
        $path = BASE_ROOT . 'language/' . $_SESSION['log_language_iso'] . '/reservation_policy.php';
        
        if( !$fo = @fopen($path,'w') ){
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to open reservation policy file for writing. Read permission denied at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['RPOLICY_READ_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        if( !@fwrite($fo, $html) ){
            @fclose($fo);
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to write into reservation policy file for writing. Write permission denied at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['RPOLICY_READ_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        @fclose($fo);
        $this->form_message = $this->lang['RPOLICY_UPDATE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /**
     * Public method: get form status
     * <br>---------------------------------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }

    /**
     * Public method: get form message 
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }

    /**
     * Public method: get form style
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}