<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class publichome
{
    protected $lang;
    protected $group = 'public';
    protected $slug = 'home';
    protected $form_status;
    protected $form_message;
    protected $form_style;
    private $car_maker_list;
    private $company_info;
    private $body_type_list;

    /*
     * Constructor
     * <br>---------------------------------------------------------------------
     */
    public function publichome($lang=array())
    {
        $this->lang = $lang;
        
        // handle subscribe form.
        if( isset($_POST['subscribebtn']) ){
            $this->handleSubscribeForm();
        }
        
        // handle search car form.
        if( isset($_POST['searchbtn']) ){
            $this->handleSearchCarForm();
        }
        
        // load car maker list.
        $this->loadCarMakerList();
        
        // load company information.
        $this->loadCompanyInformation();
    }
    
    /**
     * Private method: handle search car form.
     * <br>---------------------------------------------------------------------
     * @return void.
     */
    private function handleSearchCarForm(){
        $maker = trim($_POST['makerInput']);
        $model = trim($_POST['modelInput']);
        $body = trim($_POST['bodyInput']);
        
        // validate request.
        if( empty($maker) ){
            $maker = 'all';
        }
        if( empty($model) ){
            $model = 'all';
        }
        if( empty($body) ){
            $body = 'all';
        }
        
        // send GET to search page.
        $request = base64_encode($maker . '{_:_}' . $model . '{_:_}' . strtolower($body));
        
        header("Location: " . BASE_RELATIVE . 'home/search/?q=' . $request);
        exit;
    }
    
    /**
     * Private method: handle subscription form.
     * <br>---------------------------------------------------------------------
     * @return void.
     */
    private function handleSubscribeForm(){
        $email = trim($_POST['subscribeInput']);
        
        // validate email address.
        require_once BASE_CLASS . 'class-utilities.php';
        
        if( !Utilities::checkEmail($email) ){
            $this->form_message = $this->lang['PUBLIC_HOME_INVALID_EMAIL_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        // save email to feed table.
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $email = @mysql_real_escape_string($email);
        $ip = $_SERVER['REMOTE_ADDR'];
        $browse = $_SERVER['HTTP_USER_AGENT'];
        $date = date('Y-m-d');
        
        // check if email is already registered.
        if( !$sql = @mysql_query("SELECT `email` FROM `feedback` WHERE `email`='$email' LIMIT 1;") ){
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to save feedback new entry due a query error at ' . __FILE__ . ':' . __LINE__);
            
            $cnx->close();
            
            $this->form_message = $this->lang['PUBLIC_HOME_SUBSCRIPTION_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        if( @mysql_num_rows($sql) > 0 ){
            $cnx->close();
            
            $this->form_message = $this->lang['PUBLIC_HOME_SUBSCRIPTION_ALREADY_REGISTERED'];
            $this->form_status = true;
            $this->form_style = 'alert-success';
            
            return;
        }
        
        if( !$sql = @mysql_query("INSERT INTO `feedback` (`email`,`date`,`ip`,`browser`) VALUES ('$email','$date','$ip','$browse')") ){
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to save feedback new entry due a query error at ' . __FILE__ . ':' . __LINE__);
            
            $cnx->close();
            
            $this->form_message = $this->lang['PUBLIC_HOME_SUBSCRIPTION_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['PUBLIC_HOME_SUBSCRIPTION_QUERY_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }


    /**
     * Private method: load company information.
     * <br>---------------------------------------------------------------------
     * @return void.
     */
    private function loadCompanyInformation(){
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `company` LIMIT 1;") ){
            $cnx->close();
            
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to load company information due a query error at ' . __FILE__ . ':' . __LINE__);
            
            $this->company_info = array();
            return;
        }
        
        if( @mysql_num_rows($sql) != 1 ){
            $cnx->close();
            
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to load company information. No company information set at ' . __FILE__ . ':' . __LINE__ . ' Installation corrupted.');
            
            $this->company_info = array();
            return;
        }
        
        $r = @mysql_fetch_assoc($sql);
        @mysql_free_result($sql);
        $cnx->close();
        
        $this->company_info = array(
            'company_name' => $r['company_name'],
            'company_photo' => $r['company_photo'],
            'address' => $r['address'],
            'city' => $r['city'],
            'state' => $r['state'],
            'zip' => $r['zip'],
            'country' => $r['country'],
            'phone_1' => $r['phone_1'],
            'phone_2' => $r['phone_2'],
            'fax_1' => $r['fax_1'],
            'fax_2' => $r['fax_2'],
            'html_open_time' => stripslashes($r['html_open_time']),
            'google_map' => stripslashes($r['google_map']),
            'vat_number' => $r['vat_number'],
            'reg_number' => $r['reg_number'],
            'terms_of_use' => $r['terms_of_use'],
            'about_html' => $r['about_html']
        );
    }
    
    /**
     * Private method: load car maker list.
     * <br>---------------------------------------------------------------------
     * @return void.
     */
    private function loadCarMakerList(){
        if( count($this->car_maker_list) > 0 ){
            return $this->car_maker_list;
        }
        
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = @mysql_query("SELECT `maker`,`body_type`,`status` FROM `car` WHERE `status`='0'") ){
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to load car maker list due a query error at ' . __FILE__ . ':' . __LINE__);
            
            $cnx->close();
            return;
        }
        
        $this->car_maker_list = array();
        $this->body_type_list = array();
        
        if( @mysql_num_rows($sql) < 1 ){
            $cnx->close();
        }
        
        while( $r = @mysql_fetch_assoc($sql) ){
            array_push($this->car_maker_list, $r['maker']);
            array_push($this->body_type_list, $r['body_type']);
        }
        
        @mysql_free_result($sql);
        $cnx->close();
        
        $this->car_maker_list = array_unique($this->car_maker_list);
        $this->car_maker_list = array_values($this->car_maker_list);
        sort($this->car_maker_list);
    }
    
    /**
     * Public method: get body type list.
     * <br>---------------------------------------------------------------------
     * @return array
     */
    public function getBodyList(){
        // load body type translation list.
        $path = BASE_ROOT . 'language/' . $_SESSION['log_language_iso'] . '/car-body-types.php';
        
        if( !file_exists($path) ){
            return array();
        }
        
        require_once $path;
        
        $result = array();
        $filtered = array_unique($this->body_type_list);
        $filtered = array_values($filtered);
                
        for( $i=0; $i < count($filtered); $i++ ){
            foreach( $_CAR_BODY as $k => $v ){
                if( $k == $filtered[$i] ){
                    array_push($result, $k . ',' . $v);
                    break;
                }
            }
        }
        
        unset($filtered);
        unset($this->body_type_list);
        
        return $result;
    }
    
    /**
     * Public method: get car maker list.
     * <br>---------------------------------------------------------------------
     * @return array
     */
    public function getCarMakerList(){
        return $this->car_maker_list;
    }
    
    /**
     * Public method: get company informatiion.
     * <br>---------------------------------------------------------------------
     * @return array.
     */
    public function getCompanyInformation(){
        return $this->company_info;
    }

    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }

    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }

    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }

}
